Table of Contents
Problem
Given an array of distinct integers candidates
and a target integer target
, return a list of all unique combinations of candidates
where the chosen numbers sum to target
. You may return the combinations in any order.
The same number may be chosen from candidates
an unlimited number of times. Two combinations are unique if the frequency of at least one of the chosen numbers is different.
The test cases are generated such that the number of unique combinations that sum up to target
is less than 150
combinations for the given input.
Example 1:
Input: candidates = [2,3,6,7], target = 7 Output: [[2,2,3],[7]] Explanation: 2 and 3 are candidates, and 2 + 2 + 3 = 7. Note that 2 can be used multiple times. 7 is a candidate, and 7 = 7. These are the only two combinations.
Example 2:
Input: candidates = [2,3,5], target = 8 Output: [[2,2,2,2],[2,3,3],[3,5]]
Example 3:
Input: candidates = [2], target = 1 Output: []
Constraints:
1 <= candidates.length <= 30
2 <= candidates[i] <= 40
- All elements of
candidates
are distinct. 1 <= target <= 40
Solution
This problem asks us to list all possible combinations, so we can use backtracking to find them. However, we must avoid finding duplicated combinations. When the numbers and the number of numbers in the two combinations are the same, but the order is different, they are still the same combination. In order to avoid such a situation, when we are looking for the next number, we cannot start from candidates[0]
, we should start from the current number or the next number. However, as mentioned in the problem, numbers can be used multiple times. Therefore, we should start from the current number.
Backtracking
- Time:
- Space:
class Solution { public List<List<Integer>> combinationSum(int[] candidates, int target) { if (candidates.length == 0) return new ArrayList<>(); Set<List<Integer>> results = new HashSet<>(); combinationSum(candidates, target, 0, new ArrayList<>(), results); return new ArrayList<>(results); } private void combinationSum(int[] candidates, int target, int index, List<Integer> prefix, Set<List<Integer>> results) { if (target < 0) return; if (target == 0) { results.add(new ArrayList<>(prefix)); return; } for (int i = index; i < candidates.length; i++) { prefix.add(candidates[i]); combinationSum(candidates, target - candidates[i], i, prefix, results); prefix.remove(prefix.size() - 1); } } }
Reference
- 39. Combination Sum, LeetCode.
- 39. Combination Sum, LeetCode Solutions.